//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "TUdpCli.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)

TUdpClient::TUdpClient(TNMUDP *pNMUDP)
{
  NMUDP = pNMUDP;
  Status = 0;
  RemoteFn = "";
  LocalFn = "";
  Block = 0;
  BlockNo = 0;
  Size = 0;
  Ms = new TMemoryStream();
}

TUdpClient::~TUdpClient()
{
  delete Ms;
}

void TUdpClient::vSendLogin()
{
  char b[81] = "        11111111001111111100";
  TxnType *Txn = (TxnType*)b;

// n
  Status = 1;

  Txn->Fmt = 0x7777;
  Txn->Status = 1;
  Txn->Block = 0;
  Txn->Len = sizeof(TxnType)+20;
  NMUDP->SendBuffer((char*)Txn,sizeof(TxnType)+20,sizeof(TxnType)+20);
}

void TUdpClient::vProcessPassWord(char *Data,int Size)
{
  LoginTime = Now();;
  LastSendTime = ::GetTickCount();
}


void TUdpClient::vDisConnect()
{
// u
  Status = 0;

  TxnType Txn;
  Txn.Fmt = 0x7777;
  Txn.Status = 0;
  Txn.Block = 0;
  Txn.Len = sizeof(TxnType);
  NMUDP->SendBuffer((char*)&Txn,sizeof(TxnType),sizeof(TxnType));
}

void TUdpClient::vSendOnLine()
{
// qD{bMbuW
  TxnType Txn;
  Txn.Fmt = 0x7777;
  Txn.Status = 3;
  Txn.Block = 0;
  Txn.Len = sizeof(TxnType);
  NMUDP->SendBuffer((char*)&Txn,sizeof(TxnType),sizeof(TxnType));
}

void TUdpClient::vSendFileName()
{
  char b[20];
  TxnType *Txn = (TxnType*)b;

  Status = 5;
  RemoteFn = "PUDPSVR.EXE";
  LocalFn = "PUDPSVR.TMP";
  Block = 0;
  BlockNo = 0;
  Size =0;

  Txn->Fmt = 0x7777;
  Txn->Status = 5;
  Txn->Block = 0;
  Txn->Len = sizeof(TxnType)+12;
  strcpy(&b[8],RemoteFn.c_str());
  NMUDP->SendBuffer((char*)Txn,20,20);
  LastSendTime = ::GetTickCount();
}

void TUdpClient::vProcessFileSize(char *Data,int Size)
{
  if (Status != 5) return;
  TxnType *Txn = (TxnType*)Data;
  Status = 6;
  Block = Txn->Block;
  BlockNo = 0;
  Size =0;
  Ms->Clear();
  vSendBlockNo();
}


void TUdpClient::vSendBlockNo()
{
  TxnType Txn;
  Txn.Fmt = 0x7777;
  Txn.Status = 6;
  Txn.Block = BlockNo;
  Txn.Len = sizeof(TxnType);
  NMUDP->SendBuffer((char*)&Txn,Txn.Len,Txn.Len);
  LastSendTime = ::GetTickCount();
}

void TUdpClient::vProcessBlockNo(char *Data,int Size)
{
  if (Status != 6) return;
  TxnType *Txn = (TxnType*)Data;
  int k;

  if (Txn->Block ==  BlockNo)
  {
    k = Txn->Len-sizeof(TxnType);
    if (k > 0)
    {
      Ms->Write(&Data[sizeof(TxnType)],Txn->Len-sizeof(TxnType));
      BlockNo++;

      if (BlockNo == Block)
      {
        Ms->SaveToFile(LocalFn);
// U@
        Status = 1;
        ShowMessage(LocalFn+"U");
      }
    }
  }
  vSendBlockNo();
}

void TUdpClient::vSendGetHost()
{
  TxnType Txn;
  Txn.Fmt = 0x7777;
  Txn.Status = 7;
  Txn.Block = 0;
  Txn.Len = sizeof(TxnType);
  NMUDP->SendBuffer((char*)&Txn,Txn.Len,Txn.Len);
  LastSendTime = ::GetTickCount();
}

