//---------------------------------------------------------------------------

#include <vcl.h>
#include <stdio.h>
#include <winsock2.h>
#pragma hdrstop

#include "TUdpSvr.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)

AnsiString sGetHost()
{
  struct hostent *thisHost;
  struct in_addr in;
  char MyName[80];
  char *ptr,*hostname;
  WORD wVersionRequested;
  WSADATA wsaData;
  int i,k;

  wVersionRequested = MAKEWORD(2,0);
  if (WSAStartup(wVersionRequested,&wsaData)) return "";
  for (i=0;i<1;i++)
  {
    if( LOBYTE(wsaData.wVersion) != 2 || HIBYTE(wsaData.wVersion) != 0 ) break;
    if( gethostname(MyName,80) == SOCKET_ERROR ) break;
    thisHost=gethostbyname(MyName);
    if (thisHost == NULL) break;
    hostname = thisHost->h_name;
    memset((void*)&in,sizeof(in),0x00);

    for ( k=0 ;thisHost->h_addr_list[k]; k++ );
    k--;
    in.s_addr = *((unsigned long*)thisHost->h_addr_list[k]);

    ptr = inet_ntoa(in);
  }
  WSACleanup();
  if (ptr) return AnsiString(ptr);
  return "";
}




TUdpSvr::TUdpSvr(AnsiString Ip,long Port)
{
  PeerIP = Ip;
  PeerPort = Port;
  Active = 0;
  Connect = 0;
  LoginTime = Now();
  LastReceiveTime = ::GetTickCount();
  FilePath = "";
  FileName = "";
  BlockNo = 0;
  Ms = new TMemoryStream();
}

TUdpSvr::~TUdpSvr()
{
  if (Ms) delete Ms;
}

int TUdpSvr::iThisIpPort(AnsiString Ip,long Port)
{
  if (PeerPort != Port) return 0;
  else if (PeerIP != Ip) return 0;
  return 1;
}

int TUdpSvr::iLogin(AnsiString User,long Pwd)
{
  UserName = User;
  PassWord = Pwd;
  //ˬdKX
  return 1;
}

void TUdpSvr::vSendPassWord(TIdSocketHandle *ABinding)
{
  char p[21];
  TxnType *Txn = (TxnType*)p;
  Txn->Fmt = 0x7777;
  Txn->Status = 1;
  Txn->Block = 0;
  Txn->Len = TxnSize+8;
  sprintf(&p[TxnSize],"%08ld",PassWord%100000000);

  Connect = true;
  ABinding->SendTo(PeerIP,PeerPort,p,Txn->Len);
}

void TUdpSvr::vSendData(TIdSocketHandle *ABinding,char *Data, int Size)
{
  ABinding->SendTo(PeerIP,PeerPort,Data,Size);
}

void TUdpSvr::vSendFileBlockSize(TIdSocketHandle *ABinding,char *Data, int Size)
{
  if (Ms)
  {
    if (FileName != &Data[8])     // pOsɮ, sŪ
    {
      FileName = &Data[8];
      Ms->LoadFromFile(FileName);
    }
    TxnType *Txn = (TxnType*)Data;
    Txn->Fmt = 0x7777;
    Txn->Status = 5;
    Txn->Block = (Ms->Size+999)/1000;
    Txn->Len = Size;
    ABinding->SendTo(PeerIP,PeerPort,Txn,Txn->Len);
  }
}

void TUdpSvr::vSendBlockNo(TIdSocketHandle *ABinding,char *Data, int Size)
{
  if (Ms)
  {
    char p[1024];
    TxnType *Txn = (TxnType*)p;
    TxnType *pTxn = (TxnType*)Data;
    int k;
    Txn->Fmt = 0x7777;
    Txn->Status = 6;
    Txn->Block = pTxn->Block;
    k = Ms->Size-(long)Txn->Block*1000;
    if (k < 0) return;
    if (k>1000) k = 1000;
    Ms->Position = (long)Txn->Block*1000;
    Ms->Read(&p[TxnSize],k);
    Txn->Len = TxnSize+k;
    ABinding->SendTo(PeerIP,PeerPort,p,Txn->Len);
  }
}

