//---------------------------------------------------------------------------

#include <vcl.h>
#include <stdio.h>
#pragma hdrstop

#include "UdpSrv.h"
#include "TUdpSvr.h"
#include "TUdpCli.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "IdBaseComponent"
#pragma link "IdComponent"
#pragma link "IdUDPBase"
#pragma link "IdUDPServer"
#pragma link "IdUDPClient"
#pragma resource "*.dfm"

int Count;

TUdpClient *UdpClient;
AnsiString Ip;

TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
  Ip = sGetHost();
  Timer2->Enabled = CheckBox1->Checked;
  UdpClient = new TUdpClient(NMUDP1);
}
//---------------------------------------------------------------------------


void __fastcall TForm1::IdUDPServer1UDPRead(TObject *Sender,
      TStream *AData, TIdSocketHandle *ABinding)
{
  char *p = new char[AData->Size+1];
  unsigned short *ptr = (unsigned short *)p;
  AData->ReadBuffer(p,AData->Size);
  p[AData->Size] = 0x00;
//  ABinding->SendTo(ABinding->PeerIP,ABinding->PeerPort,p,AData->Size);
  Memo1->Lines->Add(ABinding->PeerIP+" "+ABinding->PeerPort+" "+AData->Size+" "+ptr[1]);
//  Memo1->Lines->Add(p);

  if (ptr[0] == 0x7777)
  {
    switch (ptr[1])
    {
      case 0: vDisConnect(ABinding);  // u
      break;
      case 1: vProcessLogin(ABinding,p,AData->Size); // n
      break;
      case 3: vConnecting(ABinding);  // KX,qvsuMsu
      break;
      case 5: vProcessFileName(ABinding,p,AData->Size);
      break;
      case 6: vProcessBlock(ABinding,p,AData->Size);
      break;
      case 7:
      {
        char buf[80];
        TxnType *Txn = (TxnType*)buf;
        Txn->Fmt = 0x7777;
        Txn->Status = 7;
        Txn->Block = 0;
        Txn->Len = sizeof(TxnType)+Ip.Length();
        memcpy(&buf[sizeof(TxnType)],Ip.c_str(),Ip.Length());
        ABinding->SendTo(ABinding->PeerIP,ABinding->PeerPort,buf,Txn->Len);
      } break;
      default: break;
    }
  }
  delete []p;
  Application->ProcessMessages();
}
//---------------------------------------------------------------------------


int TForm1::iThisIpPort(AnsiString Ip,long Port)
{
  int i;
  TUdpSvr *p;

  for (i=0;i<ListUdpSvr->Count;i++)
  {
    p = (TUdpSvr*)ListUdpSvr->Items[i];
    if (p->iThisIpPort(Ip,Port)) return i;
  }
  return -1;
}

int TForm1::iUserPassWordOk(AnsiString User,long Pwd)
{
  return 1;
}
void __fastcall TForm1::FormCreate(TObject *Sender)
{
  ListUdpSvr = new TList();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormDestroy(TObject *Sender)
{
  delete ListUdpSvr;
  delete UdpClient;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
  DWORD t = ::GetTickCount();
  TUdpSvr *p;
  int i;

  for (i=ListUdpSvr->Count-1;i>=0;i--)
  {
    p = (TUdpSvr*)ListUdpSvr->Items[i];
    if (p)
    {
      if ((t-p->LastReceiveTime)>60000)
      {
        ListUdpSvr->Delete(i);
        delete p;
      }
    }
  }

  if (Memo1->Lines->Count > 1000) Memo1->Clear();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Timer2Timer(TObject *Sender)
{
  DWORD t = ::GetTickCount();
  TUdpSvr *p;
  int i;
  char b[1024];
  TxnType *Txn = (TxnType*)b;
  memset(b,'A',1024);

  Count++;
  Txn->Fmt = 0x7777;
  Txn->Status = 2;
  Txn->Block = 0;
  Txn->Len = 1024;
  sprintf(&b[8],"%08ld ",Count);

  for (i=0;i<ListUdpSvr->Count;i++)
  {
    p = (TUdpSvr*)ListUdpSvr->Items[i];
    if (p)
    {
      if (p->Active)
      {
        p->vSendData(IdUDPServer1->Binding,(char*)Txn,1024);
      }
    }
  }
}
//---------------------------------------------------------------------------

void TForm1::vProcessLogin(TIdSocketHandle *ABinding,char *Data, int Size)
{
  Count = 0;
  TUdpSvr *pSvr;
  int rc;
  Memo1->Lines->Add(ABinding->PeerIP+" "+ABinding->PeerPort+" Login");
  rc = iThisIpPort(ABinding->PeerIP,ABinding->PeerPort);
  if (rc >= 0)
  {
    pSvr = (TUdpSvr*)ListUdpSvr->Items[rc];
    pSvr->vSendPassWord(ABinding);
  } else
  {
    if (ListUdpSvr->Count < 10)
    {
      Data[8+8] = 0x00;
      Data[8+18] = 0x00;
      AnsiString User = &Data[8];
      Memo1->Lines->Add(User);
      long Pwd = atol(&Data[8+10]);

      if (iUserPassWordOk(User,Pwd))
      {
        pSvr = new TUdpSvr(ABinding->PeerIP,ABinding->PeerPort);
        if (pSvr)
        {
          pSvr->iLogin(User,Pwd);
          pSvr->vSendPassWord(ABinding);
          ListUdpSvr->Add(pSvr);
        }
      }
    }
  }
  return;
}

void TForm1::vDisConnect(TIdSocketHandle *ABinding)
{
  TUdpSvr *pSvr;
  int rc;
  Memo1->Lines->Add(ABinding->PeerIP+" "+ABinding->PeerPort+" DisConnect");
  rc = iThisIpPort(ABinding->PeerIP,ABinding->PeerPort);
  if (rc >= 0)
  {
    pSvr = (TUdpSvr*)ListUdpSvr->Items[rc];
    ListUdpSvr->Delete(rc);
    delete pSvr;
  }
  return;
}

void TForm1::vConnecting(TIdSocketHandle *ABinding)
{
  TUdpSvr *pSvr;
  int rc;
  Memo1->Lines->Add(ABinding->PeerIP+" "+ABinding->PeerPort+" Connect");
  rc = iThisIpPort(ABinding->PeerIP,ABinding->PeerPort);
  if (rc >= 0)
  {
    pSvr = (TUdpSvr*)ListUdpSvr->Items[rc];
    if (pSvr->Connect) pSvr->Active = true;
    pSvr->LastReceiveTime = ::GetTickCount();
  }
  return;
}

void TForm1::vProcessFileName(TIdSocketHandle *ABinding,char *Data, int Size)
{
  TUdpSvr *pSvr;
  int rc;
  Memo1->Lines->Add(AnsiString("File:")+&Data[8]);
  rc = iThisIpPort(ABinding->PeerIP,ABinding->PeerPort);
  if (rc >= 0)
  {
    pSvr = (TUdpSvr*)ListUdpSvr->Items[rc];
    pSvr->vSendFileBlockSize(ABinding,Data,Size);
    pSvr->LastReceiveTime = ::GetTickCount();
  }
  return;
}

void TForm1::vProcessBlock(TIdSocketHandle *ABinding,char *Data, int Size)
{
  TUdpSvr *pSvr;
  int rc;
  Memo1->Lines->Add(AnsiString("BlockNo:")+*((unsigned short*)&Data[4]));
  rc = iThisIpPort(ABinding->PeerIP,ABinding->PeerPort);
  if (rc >= 0)
  {
    pSvr = (TUdpSvr*)ListUdpSvr->Items[rc];
    pSvr->vSendBlockNo(ABinding,Data,Size);
    Memo1->Lines->Add("SendBlockNo:");
    pSvr->LastReceiveTime = ::GetTickCount();
  }
  return;
}

void __fastcall TForm1::Button2Click(TObject *Sender)
{
  IdUDPServer1->Active = true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CheckBox1Click(TObject *Sender)
{
  Timer2->Enabled = CheckBox1->Checked;
}
//---------------------------------------------------------------------------












void __fastcall TForm1::ButtonSetupClick(TObject *Sender)
{
// s
//  NMUDP1->RemoteHost = EditHost->Text;
  NMUDP1->RemoteHost = "127.0.0.1";
  NMUDP1->LocalPort = 80;
  NMUDP1->RemotePort = 80;
  UdpClient->vSendGetHost();
}
//---------------------------------------------------------------------------


void __fastcall TForm1::ButtonLoginClick(TObject *Sender)
{
  NMUDP1->RemoteHost = EditHost->Text;
  UdpClient->vSendLogin();
}
//---------------------------------------------------------------------------


void __fastcall TForm1::ButtonExitClick(TObject *Sender)
{
  UdpClient->vDisConnect();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Timer3Timer(TObject *Sender)
{
  UdpClient->vSendOnLine();
  if (Memo2->Lines->Count > 1000) Memo2->Clear();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::NMUDP1DataReceived(TComponent *Sender,
      int NumberBytes, AnsiString FromIP, int Port)
{
  TxnType *Txn;

  if (NumberBytes>0)
  {
  char *p = new char[NumberBytes+1];
  NMUDP1->ReadBuffer(p,NumberBytes,NumberBytes);
  p[NumberBytes] = 0x00;

  Memo2->Lines->Add(NMUDP1->RemoteHost+" "+NumberBytes);

  Txn = (TxnType*)p;

  if (Txn->Fmt == 0x7777)
  {
    switch(Txn->Status)
    {
      case 1:
      {
        Memo2->Lines->Add("PASSWORD");
        UdpClient->vProcessPassWord(p,NumberBytes);
        UdpClient->vSendOnLine();
      } break;

      case 2:
      {
        Memo2->Lines->Add(&p[8]);
        if (CheckBox1->Checked == false)
        {
          TUdpSvr *p;
          int i;
          for (i=0;i<ListUdpSvr->Count;i++)
          {
            p = (TUdpSvr*)ListUdpSvr->Items[i];
            if (p) p->vSendData(IdUDPServer1->Binding,(char*)Txn,16);
          }
        }
      } break;

      case 5:
      {
        if (Txn->Block)
        {
          Memo2->Lines->Add(AnsiString("FILE:")+&p[8]);
          UdpClient->vProcessFileSize(p,NumberBytes);
        } else
        {
//    NEXT FILE
        }
      } break;

      case 6:
      {
        Memo2->Lines->Add(AnsiString("Block:")+*((unsigned short*)&p[4]));
        UdpClient->vProcessBlockNo(p,NumberBytes);
      } break;

      case 7:
      {
        Memo2->Lines->Add(AnsiString("Ip:")+&p[8]);
        EditHost->Text = &p[8];
      } break;
      default: break;
    }
  }
  delete []p;
  }
  Application->ProcessMessages();
}
//---------------------------------------------------------------------------



void __fastcall TForm1::Button1Click(TObject *Sender)
{
  UdpClient->vSendFileName();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Timer4Timer(TObject *Sender)
{
  if (UdpClient->Status == 5)
  {
    if (::GetTickCount() > (UdpClient->LastSendTime+500))
        UdpClient->vSendFileName();
  }
  if (UdpClient->Status == 6)
  {
    if (::GetTickCount() > (UdpClient->LastSendTime+500))
    UdpClient->vSendBlockNo();
  }

}
//---------------------------------------------------------------------------


